// DocHostHtmlView.cpp : implementation file
//

#include "stdafx.h"
#include "DocHostHtmlView.h"

#if _MFC_VER >= 0x0700
#include <afxocc.h>
#else
#include <..\src\occimpl.h>
#endif

#include "DocHostSite.h"

#include <mshtml.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDocHostHtmlView

IMPLEMENT_DYNCREATE(CDocHostHtmlView, CHtmlView)

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

BEGIN_MESSAGE_MAP(CDocHostHtmlView, CHtmlView)
	//{{AFX_MSG_MAP(CDocHostHtmlView)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


CDocHostHtmlView::CDocHostHtmlView()
	: m_pOccManager( NULL )
{
}

CDocHostHtmlView::~CDocHostHtmlView()
{
}

BOOL CDocHostHtmlView::Create(LPCTSTR lpszClassName,
							  LPCTSTR lpszWindowName,
							  DWORD dwStyle,
							  const RECT & rect,
							  CWnd * pParentWnd,
							  UINT nID,
							  CCreateContext * pContext)
{
	if (!m_pOccManager)
	{
		m_pOccManager = new CDocHostOccManager;
		ASSERT(m_pOccManager);
		if (!m_pOccManager)
			return FALSE;

		m_pOccManager->SetView( this );
	}

	::AfxEnableControlContainer( m_pOccManager );

// The rest of the code is copied form ViewHtml.cpp MFC source file

	// create the view window itself
	m_pCreateContext = pContext;
	if (!CView::Create(lpszClassName, lpszWindowName,
				dwStyle, rect, pParentWnd,  nID, pContext))
	{
		return FALSE;
	}

// We do not want this line, so comment it out!
//	AfxEnableControlContainer();

	RECT rectClient;
	GetClientRect(&rectClient);

	// create the control window
	// AFX_IDW_PANE_FIRST is a safe but arbitrary ID
	if (!m_wndBrowser.CreateControl(CLSID_WebBrowser, lpszWindowName,
				WS_VISIBLE | WS_CHILD, rectClient, this, AFX_IDW_PANE_FIRST))
	{
		DestroyWindow();
		return FALSE;
	}

	LPUNKNOWN lpUnk = m_wndBrowser.GetControlUnknown();
	HRESULT hr = lpUnk->QueryInterface(IID_IWebBrowser2, (void**) &m_pBrowserApp);
	if (!SUCCEEDED(hr))
	{
		m_pBrowserApp = NULL;
		m_wndBrowser.DestroyWindow();
		DestroyWindow();
		return FALSE;
	}

	return TRUE;
}

#if _MFC_VER >= 0x0700

BOOL CDocHostHtmlView::CreateControlSite(COleControlContainer * pContainer,
										 COleControlSite ** ppSite,
										 UINT /*nID*/,
										 REFCLSID /*clsid*/)
{
	ASSERT(m_pOccManager);
	if (!m_pOccManager)
		return FALSE;

	*ppSite = m_pOccManager->CreateSite( pContainer );

	return (*ppSite) ? TRUE : FALSE;
}

#endif

HRESULT CDocHostHtmlView::OnDocWindowActivate(BOOL)
{
	return E_NOTIMPL;
}

HRESULT CDocHostHtmlView::OnEnableModeless(BOOL)
{
	return E_NOTIMPL;
}

HRESULT CDocHostHtmlView::OnFilterDataObject(IDataObject *, IDataObject ** ppDataObject)
{
	*ppDataObject = NULL;

	return E_NOTIMPL;
}

HRESULT CDocHostHtmlView::OnFrameWindowActivate(BOOL)
{
	return E_NOTIMPL;
}

HRESULT CDocHostHtmlView::OnGetDropTarget(IDropTarget *, IDropTarget **)
{
	return E_NOTIMPL;
}

HRESULT CDocHostHtmlView::OnGetExternal(IDispatch ** lppDispatch)
{
	*lppDispatch = NULL;

	return E_NOTIMPL;
}

HRESULT CDocHostHtmlView::OnGetHostInfo(DOCHOSTUIINFO * pInfo)
{
	pInfo->dwFlags = DOCHOSTUIFLAG_NO3DBORDER;
	pInfo->dwDoubleClick = DOCHOSTUIDBLCLK_DEFAULT;

	return S_OK;
}

HRESULT CDocHostHtmlView::OnGetOptionKeyPath(LPOLESTR *, DWORD)
{
	return E_NOTIMPL;
}

HRESULT CDocHostHtmlView::OnHideUI()
{
	return S_OK;
}

HRESULT CDocHostHtmlView::OnResizeBorder(LPCRECT, IOleInPlaceUIWindow *, BOOL)
{
	return E_NOTIMPL;
}

HRESULT CDocHostHtmlView::OnShowContextMenu(DWORD, LPPOINT, IUnknown *, IDispatch *)
{
	return E_NOTIMPL;
}

HRESULT CDocHostHtmlView::OnShowUI(DWORD, IOleInPlaceActiveObject *,
								   IOleCommandTarget *, IOleInPlaceFrame *,
								   IOleInPlaceUIWindow *)
{
	return S_OK;
}

HRESULT CDocHostHtmlView::OnTranslateAccelerator(LPMSG, const GUID *, DWORD)
{
	return S_FALSE;
}

HRESULT CDocHostHtmlView::OnTranslateUrl(DWORD, OLECHAR *, OLECHAR **)
{
	return E_NOTIMPL;
}

HRESULT CDocHostHtmlView::OnUpdateUI()
{
	return S_OK;
}

#if (_WIN32_IE >= 0x0501) // IE 5.5 and higher

HRESULT CDocHostHtmlView::OnGetOverrideKeyPath(LPOLESTR *, DWORD)
{
	return E_NOTIMPL;
}

#endif

HRESULT CDocHostHtmlView::OnShowHelp(HWND, LPOLESTR, UINT,
									 DWORD, POINT, IDispatch *)
{
	return E_NOTIMPL;
}

HRESULT CDocHostHtmlView::OnShowMessage(HWND, LPOLESTR, LPOLESTR,
										DWORD, LPOLESTR, DWORD, LRESULT *)
{
	return E_NOTIMPL;
}

void CDocHostHtmlView::OnSize(UINT nType, int cx, int cy) 
{
	CHtmlView::OnSize(nType, cx, cy);
	
	// This makes sure that the browser control isn't larger than the view
	if (::IsWindow(m_wndBrowser.GetSafeHwnd())) m_wndBrowser.SetWindowPos(NULL, 0, 0, cx, cy, SWP_NOZORDER);
}
